import { Service } from "./service"
export { MemoryLockService } from "../service/memoryLockService"
export { MongodbService } from "../service/mongodbService"
export { ExpressService } from "../service/expressService"
export { RouteSessionService } from "../service/routeSessionService"
export { TTLSessionStorage } from "../service/ttlSessionStorage"
export { IncrementalIdService } from "../service/incrementalIdService"

export { DefaultPageService } from "../route/page.default"

export { UploadService } from "../service/uploadService"
export { BlobService } from "../service/blobService"
export { KeyValueStorage } from "../service/keyValueStorage"


export { MailService } from "../service/mailService"

export { PersistentService } from "../service/persistentService"
export { GracefulShutdownService } from "../service/gracefulShutdownService"

type Constructor<T> = {
    new(...any: []): T
}
export function register(cons: any, name: string = cons["name"]) {
    if (!name) {
        throw new Error("Fail to register")
    }
    module.exports[name] = cons
}
